Package org.codehaus.groovy.tools.javac

# Class JavaAwareCompilationUnit

java.lang.Object
org.codehaus.groovy.control.ProcessingUnit
org.codehaus.groovy.control.CompilationUnit
org.codehaus.groovy.tools.javac.JavaAwareCompilationUnit

    public class JavaAwareCompilationUnit
    extends CompilationUnit

Compilation Unit capable of compiling Java source files.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.codehaus.groovy.control.CompilationUnit

  `CompilationUnit.ClassgenCallback, CompilationUnit.GroovyClassOperation, CompilationUnit.IGroovyClassOperation, CompilationUnit.IPrimaryClassNodeOperation, CompilationUnit.ISourceUnitOperation, CompilationUnit.PrimaryClassNodeOperation, CompilationUnit.ProgressCallback, CompilationUnit.SourceUnitOperation`

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.control.CompilationUnit

  `ast, astTransformationsContext, classgenCallback, classNodeResolver, configured, debug, progressCallback, queuedSources, resolveVisitor, sources`

  ### Fields inherited from class org.codehaus.groovy.control.ProcessingUnit

  `classLoader, configuration, errorCollector, phase, phaseComplete`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `JavaAwareCompilationUnit()` |
  `JavaAwareCompilationUnit​(CompilerConfiguration configuration)` |
  `JavaAwareCompilationUnit​(CompilerConfiguration configuration, GroovyClassLoader groovyClassLoader)` |
  `JavaAwareCompilationUnit​(CompilerConfiguration configuration, GroovyClassLoader groovyClassLoader, GroovyClassLoader transformClassLoader)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `addSources​(File[] files)` | Adds a set of source files to the unit.
  `void` | `addSources​(String[] paths)` | Adds a set of file paths to the unit.
  `void` | `configure​(CompilerConfiguration configuration)` | Configures its debugging mode and classloader classpath from a given compiler configuration.
  `JavaCompilerFactory` | `getCompilerFactory()` |
  `void` | `gotoPhase​(int phase)` | Wraps up any pending operations for the current phase and switches to the given phase.
  `void` | `setCompilerFactory​(JavaCompilerFactory compilerFactory)` |

  ### Methods inherited from class org.codehaus.groovy.control.CompilationUnit

  `addClassNode, addFirstPhaseOperation, addFirstPhaseOperation, addJavaCompilationUnits, addNewPhaseOperation, addNewPhaseOperation, addPhaseOperation, addPhaseOperation, addPhaseOperation, addPhaseOperation, addPhaseOperation, addPhaseOperation, addSource, addSource, addSource, addSource, addSource, applyToPrimaryClassNodes, applyToSourceUnits, compile, compile, createClassVisitor, dequeued, getAST, getASTTransformationsContext, getClasses, getClassgenCallback, getClassNode, getClassNodeResolver, getFirstClassNode, getJavaCompilationUnitSet, getProgressCallback, getTransformLoader, iterator, mark, setClassgenCallback, setClassNodeResolver, setProgressCallback`

  ### Methods inherited from class org.codehaus.groovy.control.ProcessingUnit

  `completePhase, getClassLoader, getConfiguration, getErrorCollector, getPhase, getPhaseDescription, isPhaseComplete, nextPhase, setClassLoader, setConfiguration`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JavaAwareCompilationUnit

    public JavaAwareCompilationUnit()

  - ### JavaAwareCompilationUnit

    public JavaAwareCompilationUnit​(CompilerConfiguration configuration)

  - ### JavaAwareCompilationUnit

    public JavaAwareCompilationUnit​(CompilerConfiguration configuration, GroovyClassLoader groovyClassLoader)

  - ### JavaAwareCompilationUnit

    public JavaAwareCompilationUnit​(CompilerConfiguration configuration, GroovyClassLoader groovyClassLoader, GroovyClassLoader transformClassLoader)

- ## Method Details

  - ### gotoPhase

    public void gotoPhase​(int phase) throws CompilationFailedException
    Description copied from class: `ProcessingUnit`
    Wraps up any pending operations for the current phase and switches to the given phase.
    Overrides:
      `gotoPhase` in class `ProcessingUnit`
    Throws:
      `CompilationFailedException`

  - ### configure

    public void configure​(CompilerConfiguration configuration)
    Description copied from class: `CompilationUnit`
    Configures its debugging mode and classloader classpath from a given compiler configuration. This cannot be done more than once due to limitations in `URLClassLoader`.
    Overrides:
      `configure` in class `CompilationUnit`

  - ### addSources

    public void addSources​(String[] paths)
    Description copied from class: `CompilationUnit`
    Adds a set of file paths to the unit.
    Overrides:
      `addSources` in class `CompilationUnit`

  - ### addSources

    public void addSources​(File[] files)
    Description copied from class: `CompilationUnit`
    Adds a set of source files to the unit.
    Overrides:
      `addSources` in class `CompilationUnit`

  - ### getCompilerFactory

    public JavaCompilerFactory getCompilerFactory()

  - ### setCompilerFactory

    public void setCompilerFactory​(JavaCompilerFactory compilerFactory)